/**********************************************************************************************/
/* FBL_Critical.h																			  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/
 
#ifndef __FBL_Critical_h
	#define __FBL_Critical_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL.h>
#	include <VSDK/FBL_CriticalNative.h>
#else
#	include <FBL.h>
#	include <FBL_CriticalNative.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_Critical
{
	public://///////////////////////////////////////////////////////////////////////////////////
	 
								FBL_Critical( void ){
									mCritical = FBL_CreateCritical();
								}
								
virtual 						~FBL_Critical( void ){
									ForgetObject( mCritical );
								}
						
								/**< Note that critical sections are recursive: the same thread
								can re-enter a critical section without blocking. */
virtual void 					Lock( void ) 	{ mCritical->Lock(); 	}

virtual	void 					Unlock( void ) 	{ mCritical->Unlock(); 	}


	protected:////////////////////////////////////////////////////////////////////////////////// 

		FBL_CriticalNative*		mCritical;
};


/**********************************************************************************************/
class FBL_StCritical
{
	public://///////////////////////////////////////////////////////////////////////////////////
	 
								FBL_StCritical( FBL_Critical& inCritical ) :
									mCritical( inCritical )
								{
									mCritical.Lock();
								}
								
virtual 						~FBL_StCritical( void ){
									mCritical.Unlock();
								}
						
						
	protected:////////////////////////////////////////////////////////////////////////////////// 

		FBL_Critical&			mCritical;
};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif // __FBL_Critical_h