/**********************************************************************************************/
/* VDK_ImportExport.h																		  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_ImportExport_h 
	#define __VDK_ImportExport_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL.h>
#else
#	include <FBL.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
const long kVDK_errFileIsNotValid = 128;	// wrong file to import.


/**********************************************************************************************/
// opened classes:
class FBL_Set;
class FBL_Task;

// VDK classes:
class VDK_Field;

typedef FBL_Array<VDK_Field*> FieldsArray;


/**********************************************************************************************/
FBL_EXP 
FBL_Task*	MakeTaskImportASCII( 
						const FILE_PATH*	inFileImportFrom,
						FieldsArray& 		inImportMap,
						char 				inFieldDelimeter = '\t',
						char				inLineDelimeter = 13,
						const char*			inTaskName = NULL );
			
FBL_EXP 									
FBL_Task*	MakeTaskExportASCII( 
						const FILE_PATH*	inFileExportTo,
						FieldsArray& 		inExportMap,
						FBL_Set*			inSet,
						bool				inOwnsSelection	= true,
						char 				inFieldDelimeter = '\t',
						char				inLineDelimeter = 13,
						const char*			inTaskName = NULL );
			
FBL_EXP 									
FBL_Task*	MakeTaskImportFixedText( 
						const FILE_PATH*	inFileImportFrom,
						FieldsArray& 		inImportMap,
						ushort				inFieldSize[],
						const char*			inTaskName = NULL );

FBL_EXP 									
FBL_Task*	MakeTaskExportFixedText( 
						const FILE_PATH*	inFileExportTo,
						FieldsArray& 		inExportMap,
						ushort				inFieldSize[],
						FBL_Set*			inSet,
						bool				inOwnsSelection	= true,
						const char*			inTaskName = NULL );


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  

